unit skuska;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  type xfloat = real;

  type TMyObject = class
       a,b                        : integer;
       procedure Prog;                      virtual;
       function Test(x,y:xfloat)  : xfloat; virtual;
       end;

  type TMyObject2 = class(TMyObject)
       procedure Prog;                     override;
       function Test(x,y:xfloat)  :xfloat; override;
       end;

  type TMyObject3 = class(TMyObject2)
       procedure Prog;                     override;
       function Test(x,y:xfloat)  :xfloat; override;
       end;

var
  Form1                 : TForm1;
  MyObject              : TMyObject;
  MyObject2             : TMyObject2;
  MyObject3             : TMyObject3;
  Flag                  : byte;

implementation

{$R *.DFM}

function TMyObject.Test(x,y:xfloat):xfloat;
begin
     Test:=x*y;
end;

function TMyObject2.Test(x,y:xfloat):xfloat;
begin
     Test:=x*x+y*y;
end;

function TMyObject3.Test(x,y:xfloat):xfloat;
begin
     Test:=2*x+2*y;
     inherited Test(x,y);
end;

procedure TMyObject.Prog;
begin
     Flag:=1;
end;

procedure TMyObject2.Prog;
begin
     Flag:=2;
end;

procedure TMyObject3.Prog;
begin
     Flag:=3;
     inherited Prog;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     MyObject:=TMyObject.Create;
     MyObject2:=TMyObject2.Create;
     MyObject3:=TMyObject3.Create;     
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const Rozsah : integer = 32767;
begin
     MyObject.a:=MyObject.a+1;
     MyObject.b:=MyObject.b+1;
     MyObject2.a:=MyObject2.a+1;
     MyObject2.b:=MyObject2.b+1;
     MyObject3.a:=MyObject3.a+1;
     MyObject3.b:=MyObject3.b+1;
     MyObject3.Prog;
     Label1.Caption:=MyObject.ClassName+' ---> '+IntToStr(MyObject.a)+' * '+IntToStr(MyObject.b)+' = '+FloatToStr(MyObject.Test(MyObject.a,MyObject.b));
     Label2.Caption:=MyObject2.ClassName+' ---> '+IntToStr(MyObject2.a*MyObject2.a)+' + '+IntToStr(MyObject2.b*MyObject2.b)+' = '+FloatToStr(MyObject2.Test(MyObject2.a,MyObject2.b));
     Label3.Caption:=MyObject3.ClassName+' ---> '+FloatToStr(MyObject3.Test(MyObject3.a,MyObject3.b))+' ===> '+IntToStr(Flag);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     Close;
end;


end.
