unit obj;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type xfloat = real;

type TMojObject1 = class
     a,b                       :xfloat;
     function Nasob(x,y:xfloat):xfloat; virtual;
     function Vydel(x,y:xfloat):xfloat; virtual;
     procedure Test;                    virtual;
     end;

type TMojObject2 = class (TMojObject1)
     procedure Test;                    override;
     end;

type TMojObject3 = class (TMojObject2)
     end;

var
  Form1       : TForm1;
  MojObject1  : TMojObject1;
  MojObject2  : TMojObject2;
  MojObject3  : TMojObject3;
  Flag        : byte;

implementation

{$R *.DFM}

function TMojObject1.Nasob(x,y:xfloat):xfloat;
begin
     Nasob:=x*y;
end;

function TMojObject1.Vydel(x,y:xfloat):xfloat;
begin
     Vydel:=x/y;
end;

procedure TMojObject1.Test;
begin
     Flag:=1;
end;

procedure TMojObject2.Test;
begin
     Flag:=2;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     MojObject1:=TMojObject1.Create;
     MojObject2:=TMojObject2.Create;
     MojObject3:=TMojObject3.Create;     
     Beep;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
     MojObject1.Free;
     MojObject2.Free;
     MojObject3.Free;     
     Close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     MojObject1.a:=MojObject1.a+1;
     MojObject1.b:=MojObject1.b+1;
     MojObject2.a:=MojObject2.a+1;
     MojObject2.b:=MojObject2.b+1;
     MojObject1.Test;
     Label1.Caption:=MojObject1.ClassName+' = '+FloatToStr(MojObject1.Nasob(MojObject1.a,MojObject1.b))+' ---> '+IntToStr(Flag);
     MojObject3.Test;
     Label2.Caption:=MojObject2.ClassName+' = '+FloatToStr(MojObject2.Nasob(MojObject2.a,MojObject2.b))+' ---> '+IntToStr(Flag);
end;

end.
